functor
export
   SiteClass
import
   System(showInfo)
   NodeClasses(receiveNodeClass:ReceiveNode
	       sendNodeClass:SendNode
	       stringNodeClass:StringNode
	       levelNode:LevelNode)
define

class SiteClass
   feat id
   attr
      last:nil
      nodes:nil
      x
      lastsolved : nil
      lasty:1
   meth init(Id)
      self.id = Id
   end

   meth getlast($) @lasty end
   
   meth addLast(node:N)
      if @nodes == nil then
	 nodes <- N
      else
	 {@last setNext(N)}
	 {N setFront(@last)}
      end
      last <- N
   end

   meth level(L)
      N = {New LevelNode init(L)} in
      {self addLast(node:N)}
   end
   
   meth string(id:Id)
      N in
      N = {New StringNode init(id:Id)}
      {self addLast(node:N)}
   end
   
   meth send(nr:Nr 'from':S to:T  time:Time <= 0 id:Id)
      N in
      N = {New SendNode init(site:T
			     mySite:S
			     msgNr:Nr
			     time:Time
			     id:Id
			    )}
      {self addLast(node:N)}
   end
   
   meth receive(nr:Nr 'from':S to:T time:Time <= 0 id:Id)
      N in
      N = {New ReceiveNode init(site:S
				mySite:T
				msgNr:Nr
				time:Time
				id:Id
			       )}
      {self addLast(node:N)}
   end
   
   meth fix
      {@nodes fix}
   end
   meth print
      {System.showInfo  "site(id: "#self.id#" msgs:["}
      {@nodes print}
      {System.showInfo "])"}
   end

   meth getRelations($)
      {@nodes getRelations($)}
   end
   
   meth solve(Ss Ans)
      %if @lastsolved == nil then lastsolved <- @nodes end
      if @nodes == nil then Ans = nil else
	 Ans = {@nodes solve(Ss @lasty-1 $)} 
	 nodes <- @last
	 lasty<-{@nodes getYval($)}
      end
      %lastsolved <- @last
   end
end


end
