functor
import
   System(show:Show)
   EventdbClass(eventDB:EventDB)
export
   ComNodeClass ReceiveNodeClass SendNodeClass StringNodeClass LevelNode
define
   EDB = {New EventDB init(fun{$} r(send:{NewDictionary} receive:{NewDictionary}) end)}
   
   class BaseNode
      feat
	 type
	 id
      attr
	 next:nil
	 front:nil
	 y
	 beforeMe:nil
	 afterMe:nil
      meth init(id:N <= {NewName} ...)
	 self.id = N
      end

      meth pressed {System.show graphnode(pressed)} end

      meth setBeforeMe(V) beforeMe <- V end
      meth getBeforeMe(V) V = @beforeMe end
      meth setAfterMe(V) afterMe <- V end
      meth getAfterMe(V) V = @afterMe end
      meth setNext(V) next <- V end
      meth getNext(V) V = @next end
      meth setFront(V) front <- V end
      meth getFront(V) V = @front end
      meth getType(V) V = @type end

      meth getYval($) @y end
      meth setYval(Ytmp1) y <- Ytmp1  end
   
      meth getRelations($)
	 self.id#
	 if @beforeMe == nil then
	    nil
	 else
	    @beforeMe.id
	 end|
	 if @next == nil then nil
	 else {@next getRelations($)}
	 end
      end
   
      meth print
	 if @next \= nil then
	    {@next print}
	 end
      end


      meth solve(SS Nr $)
	 NN in
	 @y = NN
	 thread
	    {Wait SS}
	    @y = Nr + 1
	 end
	 solve(id:self.id y:@y)|
	 if @next == nil then
	    nil
	 else
	    {@next solve(SS NN  $)}
	 end
      end
   end

   class LevelNode from BaseNode
      feat yVal
      meth init(L) self.yVal = L end
      meth solve(SS Nr $)
	 if Nr > self.yVal then raise toHigh(Nr self.yVal) end end
	 @y = self.yVal
	 if @next == nil then
	    nil
	 else
	    {@next solve(SS self.yVal  $)}
	 end
      end
   end		      
   
    class ComNodeClass from BaseNode
      feat
	 mySite
	 site
	 msgNr
	 msgSite
	 time
      
      meth init( site:S mySite:Ms msgNr:Nr time:T ...)=M
	 self.site = S
	 self.mySite = Ms
	 self.msgNr = Nr
	 self.time = T
	 BaseNode,M
      end
    end
    


 
   class ReceiveNodeClass from ComNodeClass
      meth init(...)= M 
	 FF in
	 self.type = receive
	 ComNodeClass,M
	 FF = {EDB get(site:self.site me:self.mySite type:send nr:self.msgNr ans:$)}
	 if FF == nil then  {EDB put(site:self.mySite me:self.site type:receive nr:self.msgNr val:self)}
	 else
	    {self setBeforeMe(FF)}
	    {@beforeMe setAfterMe(self)}
	 end
      end
      
      meth print
	 {Show receive(y:@y sender:self.site  msgnr:self.msgNr time:self.time )}
	 BaseNode, print
      end
   
      meth setBeforeMe(FF)
	 BaseNode,setBeforeMe(FF)
      end

      meth solve(SS Nr $)
	 NN Link in
	 @y =  NN
	 thread
	    try
	       {Wait SS}
	       @y = {Max {@beforeMe getYval($)} + 1 Nr +1}
	       Link = @beforeMe.id
	    catch _ then
	       @y = Nr + 1
	       Link = notfound
	    end
	 end
	 
	 link(Link#self.site  self.id#self.mySite)|solve(id:self.id y:@y)|
	 if @next == nil then
	    nil
	 else
	    {@next solve(SS NN $)}
	 end
      end
   end
   


   
   
   class SendNodeClass from ComNodeClass
      feat displaymsgtype
      meth solve(SS Nr $)
	 NN in
	 @y = NN
	 thread
	       A
	       N in
	       try
		  {Wait SS}
		  @y = Nr + 1
		  A = {@afterMe getYval($)}
		  N = {@next getYval($)}
		  y <-  {Min A - 1 N -1}
		  
	       catch _ then skip end
	 end
	 solve(id:self.id y:@y)|
	 if @next == nil then
	    nil
	 else
	    {@next solve(SS NN $)}
	 end
      end
      
      meth init(...)=M
	 FF in
	 self.type = send
	 ComNodeClass, M
	 FF = {EDB get(site:self.site me:self.mySite
		       type:receive nr:self.msgNr ans:$)}
	 if FF == nil then
	    {EDB put(site:self.mySite me:self.site
		     type:send nr:self.msgNr val:self)}
	 else
	    FF.mySite = self.site
	    {self setAfterMe(FF)}
	    {@afterMe setBeforeMe(self)}
	 end
      
      end

      meth print
	 {Show send(y:@y receiver:self.site  msgnr:self.msgNr time:self.time )}
	 BaseNode, print
      end
   end

   
   class StringNodeClass from BaseNode
      meth print
	 {Show string(y:@y string)}
	 BaseNode, print
      end
      
      meth init(...)=M
	 self.type = string
	 BaseNode,M
      end
   end	    
end